unit ULecture;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, JPEG, StdCtrls, Buttons, ExtCtrls, FileCtrl;

type
  TFlect = class(TForm)
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    FileListBox1: TFileListBox;
    Label1: TLabel;
    PaintBox1: TPaintBox;
    procedure FormActivate(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DriveComboBox1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
    procedure lecture(afichier : string);
    function  DiskInDrive(Drive: Char): Boolean;
    Procedure FitRect(var arect : Trect;    // rectangle rsultat
                      var azoom : single;   // facteur de zoom utilis
                      Wdest, Hdest,         // dimensions rectangle destimation
                      Worig, Horig,         // dimensions rectangle origine
                      aMargex, aMargey : integer;  // marges rect destination
                      agrandir : boolean);
  end;

var
  Flect : TFlect;
  bmp1  : Tbitmap;    // bitmap lu

implementation

{$R *.DFM}

var
  firstaig : boolean;

{ teste si device prsent }
function TFlect.DiskInDrive(Drive: Char): Boolean;
var
  ErrorMode: word;
begin
  if Drive in ['a'..'z'] then Dec(Drive, $20);  // en majuscules
  ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
  try
    if DiskSize(Ord(Drive) - $40) = -1 then
      Result := False
    else
      Result := True;
  finally
    SetErrorMode(ErrorMode);
  end;
end;

//  Calcul du rectangle redimensionn pour qu'un rectangle origine tienne
//  dans un rectangle destination
//     - le rectangle rsultat est centr dans le rectangle destination
//     - les proportions du rectangle origine sont conserves
//  En d'autres termes il s'agit d'un stretch respectant les proportions
//
//  Le rectangle rsultat arect est relatif aux coordonnes (x0, y0) du
//  rectangle destination.
//  Le coefficient de proportionnalit utilis est renvoy dans azoom
//
//  Quand le rectangle origine est plus petit que le le rectangle destination
//  (tient sans redimensionnement dans le rectangle destination) le paramtre
//  agrandir offre 2 possibilits
//    false --> on conserve la taille origine (pas d'agrandissement)
//    true  --> on agrandit le rectangle  la taille du rectangle destination
//
Procedure TFlect.FitRect(var arect : Trect;  // rectangle rsultat
                  var azoom : single;       // facteur de zoom utilis
                  Wdest, Hdest,             // dimensions rectangle destimation
                  Worig, Horig,             // dimensions rectangle origine
                  aMargex, aMargey : integer;  // marges rect destimnation
                  agrandir : boolean);
var
  kw, kh : single;
  wd, hd, wo, ho : single;
  w , h : integer;
begin
  if (worig < 1) or (horig < 1) or (wdest < 1) or (hdest < 1) then
  begin        // protection division par 0 ou dimensions ngatives
    arect.left   := 0;
    arect.top    := 0;
    arect.right  := 0;
    arect.bottom := 0;
    azoom := 1;
    exit;
  end;
  // cas image origine plus petite sans agrandissement
  if (agrandir = false) and
     (worig <= wdest-amargex*2) and (horig <= hdest-amargey*2) then
  begin
    w := worig;
    h := horig;
    azoom := 1;
  end
  else
  begin
    wd := wdest - amargex*2;
    hd := hdest - amargey*2;
    wo := worig;
    ho := horig;
    kw := wd / wo;
    kh := hd / ho;
    // on choisit le plus petit coefficient multiplicateur
    if kw < kh then azoom := kw else azoom := kh;
    w := round(wo*azoom);
    h := round(ho*azoom);
  end;
  arect := bounds((wdest-w) div 2, (hdest-h) div 2, w, h);
end;

// lecture fichier dans Bmp1
procedure TFlect.lecture(afichier : string);
Var
  ext : string;
  ImageJPEG : TJPEGImage;
  typefich : integer;
begin
  ext := uppercase(extractfileext(afichier));
  typefich := 0;
  bmp1.free;
  bmp1 := tbitmap.create;
  IF ext = '.BMP' then typefich := 1
  else
  IF (ext = '.JPG') OR (ext = '.JPEG') then typefich := 2;
  Case typefich of
    0 : exit;
    1 : Try
          Bmp1.LoadFromFile(Afichier);
        except
          on EInvalidgraphic do
          begin
            Bmp1 := NIL;
            showmessage('Erreur lecture fichier '+Afichier);
            exit;
          end;
        end;
    2 : Try
          ImageJPEG := TJPEGImage.Create;
          try
            ImageJPEG.LoadFromFile(afichier);
          except
            on EInvalidGraphic do ImageJPEG := nil;
          end;
          IF imageJPEG = nil then
          begin
            Bmp1.width  := 100;
            Bmp1.height := 4;
            Bmp1.canvas.textout(0,0,'erreur');
          end
          else
          begin
            Bmp1.Width  := ImageJPEG.Width;
            Bmp1.Height := ImageJPEG.Height;
            Bmp1.Canvas.Draw(0,0,ImageJPEG);
          end;
        finally
          ImageJPEG.Free;
        end;
  end;  //  case
end;

{ slectionne un fichier et affiche image rduite avec proportions correctes }
procedure TFlect.FileListBox1Click(Sender: TObject);
Var
  marge : integer;
  nrect : Trect;
  kzoom : single;
begin
  marge := 23;
  IF filelistbox1.items.count < 1 then exit;
  IF filelistbox1.filename = '' then exit;
  IF Diskindrive(Drivecombobox1.drive) = False Then
  Begin
    Showmessage('Lecteur de CD-ROM ou de Disquette non prt');
    exit;
  end;
  Lecture(Filelistbox1.filename);
  if bmp1 <> Nil then
  begin
    fitrect(nrect, kzoom, panel1.width, panel1.height, bmp1.width, bmp1.height,
            marge, marge div 2, true);
    paintbox1.width  := nrect.right  - nrect.left;
    paintbox1.height := nrect.bottom - nrect.top;
    paintbox1.left   := nrect.left;
    paintbox1.top    := nrect.top;
    paintbox1.invalidate;
    Label1.caption := 'Taille '+ inttostr(bmp1.width) +
                      ' x ' + Inttostr(bmp1.height);
  end;                    
end;

procedure TFlect.FormActivate(Sender: TObject);
begin
  Filelistbox1.setfocus;
  if firstaig then
  begin
    firstaig := false;
    Filelistbox1click(sender);
  end;
end;

procedure TFlect.DirectoryListBox1Change(Sender: TObject);
begin
  IF Diskindrive(Drivecombobox1.drive) = False Then
  Begin
    Showmessage('Lecteur de CD-ROM ou de Disquette non prt');
    exit;
  end;
  Filelistbox1.Itemindex := 0;
  Filelistbox1click(sender);
  Filelistbox1.setfocus;
end;

procedure TFlect.FormCreate(Sender: TObject);
begin
  bmp1 := tbitmap.create;
  bmp1.width := 8;
  bmp1.height := 8;
  firstaig := true;
end;

procedure TFlect.DriveComboBox1Click(Sender: TObject);
begin
 IF Diskindrive(Drivecombobox1.drive) = False Then
  Begin
    Showmessage('Lecteur de CD-ROM ou de Disquette non prt');
    exit;
  end;
end;

procedure TFlect.FormDestroy(Sender: TObject);
begin
  Bmp1.free;
end;

procedure TFlect.PaintBox1Paint(Sender: TObject);
begin
  if bmp1 <> nil then
  paintbox1.canvas.stretchdraw(rect(0,0, paintbox1.width, paintbox1.height),
                                bmp1);
end;

end.
